﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace KAT_Browser
{
    public static class Querying
    {
        /// <summary>
        /// Returns the first result for now
        /// </summary>
        public static string GetFirstResultLink(string content)
        {
            string OL = GetOrderedList(content);
            string LI = GetFirstLIFromOL(OL);
            string href = GetHreffromListItem(LI);
            return "http://youtube.com/embed/" + href.Remove(0, 9);
        }

        /// <summary>
        /// Gets the ordered list that holds the results as list items for the current page
        /// </summary>
        private static string GetOrderedList(string content)
        {
            const string OL_PATTERN = @"\<ol id=""search-results"" class=""result-list context-data-container""\>.+?\</ol\>";
            Regex OLRegex = new Regex(OL_PATTERN, RegexOptions.IgnoreCase | RegexOptions.Singleline);
            Match match = OLRegex.Match(content);

            if (match.Success) return match.Value;
            else return string.Empty;
        }

        /// <summary>
        /// Getd the first list item from the specified ordered list
        /// </summary>
        private static string GetFirstLIFromOL(string OL)
        {
            const string PATTERN = @"li class=""yt-lockup2 yt-lockup2-video.+?\</li\>";
            Match match = Regex.Match(OL, PATTERN, RegexOptions.Singleline);

            if (match.Success) return match.Value;
            else return string.Empty;
        }

        /// <returns>Returns null, if title or link cannot be found</returns>
        private static string GetHreffromListItem(string listItem)
        {
            const string LINK_PATTERN = @"href=""(?<Link>/watch\?v=.+?)""";
            Match match = Regex.Match(listItem, LINK_PATTERN);

            if (match.Success) return match.Groups["Link"].Value;
            else return null;
        }
    }
}
