﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using KAT_Browser.Properties;

namespace KAT_Browser
{
    public partial class SettingsForm : Form
    {
        public SettingsForm()
        {
            InitializeComponent();

            LoadSettingsAndDefaults();
        }

        private void LoadSettingsAndDefaults()
        {
            if (!DesignMode)
            {
                pathPickerTorrent.FullPath = Settings.Default.TorrentDest;
                chkAppendTrailer.Checked = Settings.Default.AppendTrailerWord;
                chkOpenTorrents.Checked = Settings.Default.OpenTorrents;
            }
        }

        private void btnDone_Click(object sender, EventArgs e)
        {
            Settings.Default.TorrentDest = pathPickerTorrent.FullPath;
            Settings.Default.AppendTrailerWord = chkAppendTrailer.Checked;
            Settings.Default.OpenTorrents = chkOpenTorrents.Checked;
            this.Close();
        }

        private void pathPickerTorrent_Click(object sender, EventArgs e)
        {
            using (FolderBrowserDialog dlgFolderBrowser = new FolderBrowserDialog())
            {
                if (Settings.Default.TorrentDest.Length > 0)
                {
                    dlgFolderBrowser.SelectedPath = Settings.Default.TorrentDest;
                }

                if (dlgFolderBrowser.ShowDialog() == DialogResult.OK)
                {
                    pathPickerTorrent.FullPath = dlgFolderBrowser.SelectedPath;
                }
            }
        }
    }
}
