﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace KAT_Browser
{
    class PreviewRetriever : BackgroundWorker
    {
        private Exception _exception;
        private string _result;

        protected override void OnDoWork(DoWorkEventArgs e)
        {
            base.OnDoWork(e);
            string address = GetAdress(e.Argument.ToString());

            WebClient webClient = new WebClient();

            try
            {
                string content = webClient.DownloadString(address);
                _result = Querying.GetFirstResultLink(content);
            }
            catch (Exception ex)
            {
                _exception = ex;
            }
        }

        protected override void OnRunWorkerCompleted(RunWorkerCompletedEventArgs e)
        {
            e = new RunWorkerCompletedEventArgs(_result, _exception, e.Cancelled);
            base.OnRunWorkerCompleted(e);
        }

        /// <summary>
        /// Creates a web adress from the torrent name for lookup
        /// </summary>
        private static string GetAdress(string torrentName)
        {
            string searchTerm = ProcessName(torrentName);
            const string BASE_URL = @"http://www.youtube.com/results?search_query=";
            string result = BASE_URL + searchTerm;

            if (Properties.Settings.Default.AppendTrailerWord)
            {
                result += "+Trailer";
            }

            return result;
        }

        /// <summary>
        /// Processes the name so that the torrent title is appropriate for youtube lookup
        /// </summary>
        private static string ProcessName(string torrentName)
        {
            torrentName = torrentName.Replace('.', '+');
            torrentName = torrentName.Replace(' ', '+');

            const string PATTERN = @"^(?<Name>.+?)\+(\d\d\d\d|xvid|divx|acc|aac|dvdrip|dvdscr|dvdr|br*rip|dvdscreener)";
            Match match = Regex.Match(torrentName, PATTERN, RegexOptions.IgnoreCase);

            if (match.Success)
            {
                return match.Groups["Name"].Value;
            }

            return torrentName;
        }
    }
}
